-- model.lua

model = {}


----------------------------------------------------------------------------
-- Tap the item layouts
----------------------------------------------------------------------------
model.threeObjectLayout = function(point1, point2, point3)
    local self={}
    
    --private field
    local layout={point1, point2, point3}
    local tab={}
    
    self.getFirstPoint = function()
        return layout[1]
    end
    self.getSecondPoint = function()
        return layout[2]
    end
    self.getThirdPoint = function()
        return layout[3]
    end
    
    return self
end



model.twoObjectLayout = function(startPoint1, point1, startPoint2, point2)
    local self={}
    
    --private field
    local layout={point1, point2}
    local startPoints={startPoint1, startPoint2}
    local tab={}
    
    self.getFirstPoint = function()
        return layout[1]
    end
    self.getSecondPoint = function()
        return layout[2]
    end
    self.getFirstStartingPoint = function()
        return startPoints[1]
    end
    self.getSecondStartingPoint = function()
        return startPoints[2]
    end
    
    
    return self
end

model.iterator = function(tab)
    self={}
    local current=1
    
    self.getCurrent = function()
        return tab[current]
    end
    
    self.next = function()
        if (current == table.getn(tab)) then
            current=1
        else
            current=current+1
        end

    end
    
    return self

end

model.point = function(x,y)
    local self={}
    
    --private fields
    local x=x
    local y=y
    
    self.getX = function()
        return x
    end
    
    self.getY = function()
        return y
    end

    return self
end

model.clean = function(a, len)
    local b={}
    local i = 1
    local j = 1
    while (j<=len) do
        if a[j]==nil then
            j=j+1
        else
            b[i]=a[j]
            i=i+1
            j=j+1
        end
    end
    return b
end





