-- app.lua

app = {}

vars:setVar("animationCounter","0")

----------------------------------------------------------------------------
-- Randomization (shuffle object)
----------------------------------------------------------------------------
-- Initialize the pseudo random number generator
        math.randomseed( tonumber(tostring(os.time()):reverse():sub(1,6)) )
        math.random(); math.random(); math.random()
----------------------------------------------------------------------------
        

app.shuffleClass = function(num)

    local self={}
    local num=num
    local tab={}
    local c={}
    local current=1
    ----------clean function----
    self.clean = function(a, len)
        local b={}
        local i = 1
        local j=1
        while (j<=len) do
            if a[j]==nil then
                j=j+1
            else
                b[i]=a[j]
                i=i+1
                j=j+1
            end
        end
        return b
    end
    ------------------------------

    ----------shuffle function--------
    self.shuffle = function(tabToShuffle)

        for i=1,num do
            c[i]=i
        end
        --if tabToShuffle is not present, use c
        c = tabToShuffle or c
        
        --clean of nil values
        --c=self.clean(c, num)

        for i=1,num do
            j=num+1-i
            --print("j: ",j)
            a=math.random(1,j)
            --print("a:", a)
            b=c[a]
            tab[i]=b
            --print(tab[i])
            c[a]=nil
            c=self.clean(c,j)
        end
        return tab

    end
    
    self.get = function(val)
        return tab[val]
    end
    
    self.getCurrent = function()
        return tab[current]
    end
    self.next = function()
        if (current == num) then
            current = 1
        else
            current=current+1
        end
    end




    return self

end

----------------------------------------------------------------------------
-- Tap The Item
----------------------------------------------------------------------------

app.tapTheItem = function()
    local self={}
    
    --private fields
    local numOfItems=0
    local twoObjectLayout
    local threeObjectLayout

    --this tab is used for the suffled items
    local tab={}

    --local tabToShuffle={}
    local origTab={}
    local round={}
    --member used to remember the last object
    local lastObject=-1

    self.initTwoObjectLayout = function (point1, point2, point3, point4)
        twoObjectLayout = model.twoObjectLayout(point1, point2, point3, point4)
    end
    
    self.initThreeObjectLayout = function (point1, point2, point3)
        threeObjectLayout = model.threeObjectLayout(point1, point2, point3)
    end

    self.add = function (item, notification)
        
        numOfItems=numOfItems + 1
        origTab[numOfItems]={item, notification}
        tab[numOfItems]={item, notification}


    end
    
    self.shuffleItems = function()
        --copy relevant objects to tab
        print("shuffle----------")
        if lastObject ~= -1 then
            for i=1,numOfItems do
                if i~=lastObject then
                    tab[i]=origTab[i]
                    --print(tab[i][1].." "..origTab[i][1])

                else
                    tab[i] = nil
                    --print("nil "..origTab[i][1])
                end


            end
            --clean tab
            tab=model.clean(tab, numOfItems)
            
            --print check
            --for i=1,numOfItems-1 do
                --print(tab[i][1].." "..i)
            --end

            shuffleObject=app.shuffleClass(numOfItems-1)
            tab=shuffleObject.shuffle(tab)
            --for i=1,numOfItems-1 do
                --print(tab[i][1].." "..i)
            --end
        else
            shuffleObject=app.shuffleClass(numOfItems)
            tab=shuffleObject.shuffle(tab)
        end





    end

    self.newRound = function()

    

       --pick the first two items (presumebly shuffleItems was used), put them in twoObjectLayout.
       --clear round table
       round={}
        roundType=math.random(1,2)
        print("lastObject: "..lastObject)
        if (roundType == 1) then
            round[1]={tab[1][1], tab[1][2], twoObjectLayout.getFirstPoint(), twoObjectLayout.getFirstStartingPoint() }
            round[2]={tab[2][1], tab[2][2], twoObjectLayout.getSecondPoint(), twoObjectLayout.getSecondStartingPoint() }
            round[3]="none"
            local chosenObject=math.random(1,2)
            round[5]=round[chosenObject][1]
            round[6]=round[chosenObject][3]
            lastObject = self.getOrigIndexByNotification(round[chosenObject][2])
            print(tab[1][1])
            print(tab[2][1])
        else
            round[1]={tab[1][1], tab[1][2], threeObjectLayout.getFirstPoint()}
            round[2]={tab[2][1], tab[2][2], threeObjectLayout.getSecondPoint()}
            round[3]={tab[3][1], tab[3][2], threeObjectLayout.getThirdPoint()}
            local chosenObject=math.random(1,3)
            round[5]=round[chosenObject][1]
            round[6]=round[chosenObject][3]
            lastObject = self.getOrigIndexByNotification(round[chosenObject][2])
            print(tab[1][1])
            print(tab[2][1])
            print(tab[3][1])

        end

    end

    self.firstNotification = function ()

        return(round[1][2])
    end
    self.secondNotification = function ()

        return(round[2][2])
    end
    
    self.thirdNotification = function ()
        if round[3] == "none" then
            return "none"
        else
            return(round[3][2])
        end
    end



    self.getFirstObject = function ()

        print(round[1][1])
    end

    self.getSecondObject = function ()
        print(round[2][1])
    end

    self.getOrigIndexByNotification = function(notif)
        for i=1,numOfItems do
            if (origTab[i][2] == notif) then
                return i
            end
        end
        return -100
    end

    
    self.getXPosByNotification = function(notif)
        for i=1,3 do
            if (round[i][2] == notif) then
                return round[i][3].getX()
            end
        end
        return -100
    end
    
    self.getStartXPosByNotification = function(notif)
        for i=1,3 do
            if (round[i][2] == notif) then
                return round[i][4].getX()
            end
        end
        return -100
    end
    
    self.getYPosByNotification = function(notif)
        for i=1,3 do
            if (round[i][2] == notif) then
                return round[i][3].getY()
            end
        end
        return -100
    end
    self.getStartYPosByNotification = function(notif)
        for i=1,3 do
            if (round[i][2] == notif) then
                return round[i][4].getY()
            end
        end
        return -100
    end
    
    self.getChosenObject = function()
        return round[5]
    end

    self.getChosenObjectX = function()
        return (round[6].getX())
    end
    
    self.getChosenObjectY = function()
        return (round[6].getY())
    end

    self.iterator = function ()
        return model.iterator(tab)
    end
    
    return self
end



----------------------------------------------------------------------------
-- Services
----------------------------------------------------------------------------

srvc = {}
srvc.isAndroid = function()
    print("srvc.isAndroid "..tostring(isAndroid).."")
    return (isAndroid == 1)
end



